博客
关于我
2021牛客寒假算法基础集训营3
阅读量:259 次
发布时间:2019-03-01

本文共 6804 字,大约阅读时间需要 22 分钟。

三场牛客下来觉得自己越来越不在状态,思路不清晰,一下手就是bug,每调完一题刷下榜都被甩开十里地,罚时惨不忍睹

D. Happy New Year!

签到

#include 
using namespace std;typedef long long ll;const ll inf = 0x3f3f3f3f;const ll mod = 1000000007;const ll N = 4e6 + 7;int main() { int n; scanf("%d", &n); int sum = 0, tmp = n; while(tmp) { sum += tmp % 10; tmp /= 10; } for(int i = n + 1; ; ++i) { int tmp = i, cnt = 0; while(tmp) { cnt += tmp % 10; tmp /= 10; } if(cnt == sum) { printf("%d\n", i); break; } } return 0;}

G. 糖果

同一连通块中的小朋友的糖数必定相同且为他们中最大的需求值。

边没必要去重,憨批一样白给了一发

#include 
using namespace std;typedef long long ll;const int inf = 0x3f3f3f3f;const int mod = 1000000007;const int N = 1e6 + 7;inline int read() { int x = 0, f = 1; char ch = getchar(); while(!isdigit(ch)) { if(ch == '-') f = -1; ch = getchar(); } while(isdigit(ch)) { x = (x << 1) + (x << 3) + (ch ^ 48); ch = getchar(); } return x * f;}int a[N], n, m, maxx, cnt;bool vis[N];vector
mp[N];void dfs(int u) { vis[u] = 1; cnt++, maxx = max(maxx, a[u]); int siz = mp[u].size(); for(int i = 0; i < siz; ++i) { int v = mp[u][i]; if(vis[v]) continue; dfs(v); }}int main() { int u, v; n = read(), m = read(); for(int i = 1; i <= n; ++i) mp[i].clear(); for(int i = 1; i <= n; ++i) a[i] = read(); for(int i = 1; i <= m; ++i) { u = read(), v = read(); mp[u].emplace_back(v); mp[v].emplace_back(u); } for(int i = 1; i <= n; ++i) vis[i] = 0; ll ans = 0; for(int i = 1; i <= n; ++i) { if(vis[i]) continue; maxx = cnt = 0; if(mp[i].empty()) maxx = a[i], cnt = 1; else dfs(i); ans += 1ll * maxx * cnt; } printf("%lld\n", ans); return 0;}

H. 数字串

把除 j = 10、t = 20之外的一个 > j 的字母拆成俩即可,如果没有这样的字母,找是否有两个字母可以合成一个,注意 j、t 不可更改且不可合并

#include 
using namespace std;typedef long long ll;const int inf = 0x3f3f3f3f;const int mod = 1000000007;const int N = 1e6 + 7;int main() { string s, str = ""; cin >> s; int n = s.size(); bool flag = 0; for(int i = 0; i < n; ++i) { int a = s[i] - 'a' + 1; if(!flag && a > 10 && a != 20) { int c = a % 10; int b = (a / 10) % 10; str += char(b - 1 + 'a'); str += char(c - 1 + 'a'); flag = 1; } else str += s[i]; } if(!flag) { int id = -1, tmp; for(int i = 1; i < n; ++i) { if(s[i] == 'j' || s[i] == 't') continue; int b = s[i - 1] - 'a' + 1; int c = s[i] - 'a' + 1; if(b * 10 + c <= 26) { id = i - 1; tmp = b * 10 + c; break; } } if(id == -1) { printf("-1\n"); return 0; } for(int i = 0; i < n; ++i) { if(i == id) cout << char(tmp - 1 + 'a'), ++i; else cout << s[i]; } cout << '\n'; } else cout << str << '\n'; return 0;}

I. 序列的美观度

直接顺序更新答案,las[x] 记录 x 上一次出现时的答案,扫到第 i 个位置时,首先判断a[i]是否等于a[i - 1],是则答案++,然后判断 las[a[i]] 和当前答案的关系,若二者相等,说明上一个数a[i]出现的位置和当前位置之间的这一段序列没有任何贡献,还不如把它们删掉让两个a[i]靠着贡献1,所以此时答案++,更新las[a[i]]

赛时思路极其不清晰 4wa

#include 
using namespace std;typedef long long ll;const int inf = 0x3f3f3f3f;const int mod = 1000000007;const int N = 1e6 + 7;int a[N], las[N];int main() { int n; scanf("%d", &n); for(int i = 1; i <= n; ++i) scanf("%d", &a[i]); memset(las, -1, sizeof(las)); int cnt = 0; las[a[1]] = 0; for(int i = 2; i <= n; ++i) { if(a[i] == a[i - 1]) cnt++; if(las[a[i]] == cnt) cnt++; las[a[i]] = cnt; } printf("%d\n", cnt); return 0;}

J. 加法和乘法

奇 + 奇 = 偶,奇 * 奇 = 奇

奇 + 偶 = 奇,奇 * 偶 = 偶

偶 + 偶 = 偶,偶 * 偶 = 偶

牛妹总能将任意两个数变成偶数,如果最后一步是牛妹,即n是奇数,则牛妹必胜

牛牛要变出一个奇数的前提是两个数中至少要有一个奇数,所以牛妹会在每次操作尽量消除奇数,牛牛会尽量消除偶数,牛妹的每次操作最多消除两个奇数,增加一个偶数,而牛牛最多消除一个偶数,可以发现如果原序列中多于一个偶数,到最后不会剩下奇数,所以牛牛赢的条件是n 是偶数且数列中<=1个偶数

特判特判特判 n == 1!!!

#include 
using namespace std;typedef long long ll;const int inf = 0x3f3f3f3f;const int mod = 1000000007;const int N = 1e6 + 7;int main() { int n, a, cnt = 0; scanf("%d", &n); for(int i = 1; i <= n; ++i) { scanf("%d", &a); if(a % 2 == 0) cnt++; } if(n == 1) { if(cnt == 0) printf("NiuNiu\n"); else printf("NiuMei\n"); } else { if((n & 1) || cnt > 1) printf("NiuMei\n"); else printf("NiuNiu\n"); } return 0;}

F. 匹配串

判断n个字符串的首尾是不是有矛盾的,没有矛盾都是无穷个

鉴于罚时已经无可救药,样例过了就交了,没想到1A

#include 
using namespace std;typedef long long ll;const int inf = 0x3f3f3f3f;const int mod = 1000000007;const int N = 1e6 + 7;int be[N], ed[N];string s[N];int main() { int n, max1 = -1, max2 = -1, id1, id2; scanf("%d", &n); for(int i = 1; i <= n; ++i) { cin >> s[i]; int len = s[i].size(); for(int j = 0; j < len; ++j) { if(s[i][j] == '#') { be[i] = j - 1; if(max1 < be[i]) { max1 = be[i]; id1 = i; } break; } } for(int j = len - 1; j >= 0; --j) { if(s[i][j] == '#') { ed[i] = j + 1;// cout<

C. 重力坠击

写了一个多小时的暴力硬是没写对????????真绝了,手是个好东西然鹅我没有

warning:

1、当你的暴力wa掉n遍时,球球不要再debug了,重写吧

2、bitset真香,怎么就没想到要用呢

————哈——哈—

#include 
using namespace std;typedef long long ll;const int inf = 0x3f3f3f3f;const int mod = 1000000007;const int N = 1007;struct node { int x, y, r;} s[12];bitset<12>bit[N];bool check(node a, node b) { return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= (a.r + b.r) * (a.r + b.r);}int op = 7;int main() { int n, k, R; scanf("%d%d%d", &n, &k, &R); for(int i = 1; i <= n; ++i) scanf("%d%d%d", &s[i].x, &s[i].y, &s[i].r); for(int i = 0; i < N; ++i) bit[i].reset(); int tot = 0; for(int xx = -op; xx <= op; ++xx) { for(int yy = -op; yy <= op; ++yy) { ++tot; for(int i = 1; i <= n; ++i) if(check(node{xx, yy, R}, s[i])) bit[tot].set(i); } } int ans = 0; for(int i = 1; i <= tot; ++i) { bitset<12>tmp1 = bit[i]; if(k == 1) { ans = max(ans, (int)tmp1.count()); continue; } for(int j = i + 1; j <= tot; ++j) { bitset<12>tmp2 = bit[i] | bit[j]; if(k == 2) { ans = max(ans, (int)tmp2.count()); continue; } for(int k = j + 1; k <= tot; ++k) { bitset<12>tmp3 = bit[i] | bit[j] | bit[k]; ans = max(ans, (int)tmp3.count()); } } } printf("%d\n", ans); return 0;}

还没补完,南京站以来懈怠了很多,手生了不少,忙活这忙活那,就是没有沉下心来,浪费了一个月。明天补完,cf我来啦!!!

转载地址:http://tcio.baihongyu.com/

你可能感兴趣的文章